package uoc.tfg.g2tde.controllers;

import java.security.Principal;

import org.springframework.security.access.annotation.Secured;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;

@Controller
public class LoginController {

	@GetMapping("/login")
	public String login(@RequestParam(value="error", required=false) String error,
			@RequestParam(value="logout", required = false) String logout,
			Model model, Principal principal, RedirectAttributes flash) {
		
		if(principal != null) {
			flash.addFlashAttribute("info", "La sesión ya ha sido iniciada");
			return "redirect:/";
		}
		
		if(error != null) {
			model.addAttribute("error", "Error en el inicio de sesión");
		}
		
		if(logout != null) {
			model.addAttribute("success", "Ha cerrado sesión con éxito!");
		}
		
		return "login";
	}
	
	@Secured({"ROLE_GESTION", "ROLE_OPERADOR","ROLE_ADMIN"})
	@GetMapping({"/","/home"})
	public String home(Model model) {
		model.addAttribute("title", "Home");
		
		return "/home";
	}
}
