package uoc.tfg.g2tde.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

@Repository
public class CriterioReglaDao implements ICriterioReglaDao{
	
	@PersistenceContext
	private EntityManager entityManager;
	
	@SuppressWarnings("unchecked")
	@Override
	public List<Long> getByIdCriterio(@Param("criterioId") Long criterioId) {
		Query query = entityManager.createNativeQuery("select regla_id from criterio_regla where criterio_id = :criterio_id");
		query.setParameter("criterio_id", criterioId);
		return query.getResultList();
	}
	
	@Override
	public void deleteByIdCriterio(@Param("criterioId") Long criterioId) {
		Query query = entityManager.createNativeQuery("delete criterio_regla where criterio_id = :criterio_id");
		
		query.setParameter("criterio_id", criterioId);
		
		query.executeUpdate();
	}
}
