package uoc.tfg.g2tde.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.tfg.g2tde.dao.ClienteDao;
import uoc.tfg.g2tde.entities.Cliente;
import uoc.tfg.g2tde.interfaces.IClienteService;

@Service
public class ClienteService implements IClienteService{
	
	@Autowired
	private ClienteDao clienteDao;
	
	@Override
	public List<Cliente> findAll() {
		return (List<Cliente>)clienteDao.findAll();
	}

	@Override
	public Page<Cliente> findAll(Pageable pageable) {
		return clienteDao.findAll(pageable);
	}

	@Override
	@Transactional
	public void save(Cliente Cliente) {
		clienteDao.save(Cliente);
	}

	@Override
	public Optional<Cliente> findById(Long id) {
		return clienteDao.findById(id);
	}

	@Override
	@Transactional
	public void deleteById(Long id) {
		clienteDao.deleteById(id);
	}
}
