package uoc.tfg.g2tde.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.tfg.g2tde.interfaces.IConsultoriaService;

import uoc.tfg.g2tde.dao.ConsultoriaDao;
import uoc.tfg.g2tde.entities.Consultoria;

@Service
public class ConsultoriaService implements IConsultoriaService{

	@Autowired
	private ConsultoriaDao consultoriaDao;

	@Override
	public List<Consultoria> findAll() {
		return (List<Consultoria>)consultoriaDao.findAll();
	}

	@Override
	public Page<Consultoria> findAll(Pageable pageable) {
		return consultoriaDao.findAll(pageable);
	}

	@Override
	@Transactional
	public void save(Consultoria consultoria) {
		consultoriaDao.save(consultoria);
	}

	@Override
	public Optional<Consultoria> findById(Long id) {
		return consultoriaDao.findById(id);
	}

	@Override
	@Transactional
	public void deleteById(Long id) {
		consultoriaDao.deleteById(id);
	}
}
