package uoc.tfg.g2tde.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.tfg.g2tde.dao.CriterioDao;
import uoc.tfg.g2tde.entities.Criterio;
import uoc.tfg.g2tde.interfaces.ICriterioService;

@Service
public class CriterioService implements ICriterioService{
	
	@Autowired
	private CriterioDao criterioDao;

	@Override
	public List<Criterio> findAll() {
		return (List<Criterio>)criterioDao.findAll();
	}

	@Override
	public Page<Criterio> findAll(Pageable pageable) {
		return criterioDao.findAll(pageable);
	}

	@Transactional
	@Override
	public void save(Criterio criterio) {
		criterioDao.save(criterio);
	}

	@Override
	public Optional<Criterio> findById(Long id) {
		return criterioDao.findById(id);
	}

	@Transactional
	@Override
	public void deleteById(Long id) {
		criterioDao.deleteById(id);
	}

	@Override
	public List<Criterio> findByUsuarioUsername(String username) {
		return criterioDao.findByUsuarioUsername(username);
	}
}
