package uoc.tfg.g2tde.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.tfg.g2tde.dao.EmpleadoClienteTareaDao;
import uoc.tfg.g2tde.entities.EmpleadoClienteTarea;
import uoc.tfg.g2tde.interfaces.IEmpleadoClienteTareaService;

@Service
public class EmpleadoClienteTareaService implements IEmpleadoClienteTareaService{

	@Autowired
	private EmpleadoClienteTareaDao empleadoClienteTareaDao;

	@Override
	public Optional<EmpleadoClienteTarea> findById(Long id) {
		return empleadoClienteTareaDao.findById(id);
	}
	
	@Override
	public List<EmpleadoClienteTarea> findAll() {
		return (List<EmpleadoClienteTarea>)empleadoClienteTareaDao.findAll();
	}
	
	@Transactional
	@Override
	public void save(EmpleadoClienteTarea empleadoClienteTarea) {
		empleadoClienteTareaDao.save(empleadoClienteTarea);
	}
	
	@Transactional
	@Override
	public void deleteById(Long id) {
		empleadoClienteTareaDao.deleteById(id);
	}

	@Override
	public List<EmpleadoClienteTarea> findByClienteId(Long clientId) {
		return empleadoClienteTareaDao.findByClienteId(clientId);
	}
}
