package uoc.tfg.g2tde.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.tfg.g2tde.dao.EmpleadoDao;
import uoc.tfg.g2tde.entities.Empleado;
import uoc.tfg.g2tde.interfaces.IEmpleadoService;

@Service
public class EmpleadoService implements IEmpleadoService{

	@Autowired
	private EmpleadoDao empleadoDao;

	@Override
	public List<Empleado> findAll() {
		return (List<Empleado>)empleadoDao.findAll();
	}

	@Override
	public Page<Empleado> findAll(Pageable pageable) {
		return empleadoDao.findAll(pageable);
	}

	@Transactional
	@Override
	public void save(Empleado empleado) {
		empleadoDao.save(empleado);
	}

	@Override
	public Optional<Empleado> findById(Long id) {
		return empleadoDao.findById(id);
	}

	@Transactional
	@Override
	public void deleteById(Long id) {
		empleadoDao.deleteById(id);
	}
}
