package uoc.tfg.g2tde.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.tfg.g2tde.dao.InformeDao;
import uoc.tfg.g2tde.entities.Informe;
import uoc.tfg.g2tde.interfaces.IInformeService;

@Service
public class InformeService implements IInformeService{

	@Autowired
	private InformeDao informeDao;

	@Override
	public List<Informe> findAll() {
		return (List<Informe>)informeDao.findAll();
	}

	@Override
	public Page<Informe> findAll(Pageable pageable) {
		return informeDao.findAll(pageable);
	}

	@Transactional
	@Override
	public void save(Informe informe) {
		informeDao.save(informe);
	}

	@Override
	public Optional<Informe> findById(Long id) {
		return informeDao.findById(id);
	}

	@Transactional
	@Override
	public void deleteById(Long id) {
		informeDao.deleteById(id);
	}

	@Override
	public List<Informe> findByUsuarioUsername(String username) {
		return informeDao.findByUsuarioUsername(username);
	}
}
