package uoc.tfg.g2tde.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.tfg.g2tde.dao.ReglaCriterioOperadorDao;
import uoc.tfg.g2tde.entities.ReglaCriterioOperador;
import uoc.tfg.g2tde.interfaces.IReglaCriterioOperadorService;

@Service
public class ReglaCriterioOperadorService implements IReglaCriterioOperadorService{

	@Autowired
	private ReglaCriterioOperadorDao reglaCriterioOperadorDao;

	@Override
	public Optional<ReglaCriterioOperador> findById(Long id) {
		return reglaCriterioOperadorDao.findById(id);
	}
	
	@Override
	public List<ReglaCriterioOperador> findAll() {
		return (List<ReglaCriterioOperador>)reglaCriterioOperadorDao.findAll();
	}
	
	@Transactional
	@Override
	public void save(ReglaCriterioOperador reglaCriterioOperador) {
		reglaCriterioOperadorDao.save(reglaCriterioOperador);
	}
	
	@Transactional
	@Override
	public void deleteById(Long id) {
		reglaCriterioOperadorDao.deleteById(id);
	}
}
