package uoc.tfg.g2tde.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.tfg.g2tde.dao.ReglaDao;
import uoc.tfg.g2tde.entities.Regla;
import uoc.tfg.g2tde.interfaces.IReglaService;

@Service
public class ReglaService implements IReglaService{

	@Autowired
	private ReglaDao reglaDao;

	@Override
	public List<Regla> findAll() {
		return (List<Regla>)reglaDao.findAll();
	}

	@Override
	public Page<Regla> findAll(Pageable pageable) {
		return reglaDao.findAll(pageable);
	}

	@Transactional
	@Override
	public Regla save(Regla regla) {
		return reglaDao.save(regla);
	}

	@Override
	public Optional<Regla> findById(Long id) {
		return reglaDao.findById(id);
	}

	@Transactional
	@Override
	public void deleteById(Long id) {
		reglaDao.deleteById(id);
	}

	@Override
	public List<Regla> findByConclusionId(Long id) {
		return reglaDao.findByConclusionId(id);
	}

	@Override
	public List<Regla> findByUsuarioUsername(String username) {
		return reglaDao.findByUsuarioUsername(username);
	}
}
