package uoc.tfg.g2tde.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.tfg.g2tde.dao.RolDao;
import uoc.tfg.g2tde.entities.Rol;
import uoc.tfg.g2tde.interfaces.IRolService;

@Service
public class RolService implements IRolService{

	@Autowired
	private RolDao rolDao;

	@Override
	public List<Rol> findAll() {
		return (List<Rol>)rolDao.findAll();
	}

	@Override
	public Page<Rol> findAll(Pageable pageable) {
		return rolDao.findAll(pageable);
	}

	@Transactional
	@Override
	public void save(Rol rol) {
		rolDao.save(rol);
	}

	@Override
	public Optional<Rol> findById(Long id) {
		return rolDao.findById(id);
	}
	
	@Transactional
	@Override
	public void deleteById(Long id) {
		rolDao.deleteById(id);
	}
}
