package uoc.tfg.g2tde.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uoc.tfg.g2tde.dao.TareaDao;
import uoc.tfg.g2tde.entities.Tarea;
import uoc.tfg.g2tde.interfaces.ITareaService;

@Service
public class TareaService implements ITareaService{

	@Autowired
	private TareaDao tareaDao;

	@Override
	public List<Tarea> findAll() {
		return (List<Tarea>)tareaDao.findAll();
	}

	@Override
	public Page<Tarea> findAll(Pageable pageable) {
		return tareaDao.findAll(pageable);
	}

	@Transactional
	@Override
	public Tarea save(Tarea tarea) {
		return tareaDao.save(tarea);
	}

	@Override
	public Optional<Tarea> findById(Long id) {
		return tareaDao.findById(id);
	}

	@Transactional
	@Override
	public void deleteById(Long id) {
		tareaDao.deleteById(id);
	}
}
